This is the readme file for ImageCraft ICCV8 for Cortex Compiler.

Make sure you subscribe to the icc-cortex mailing list for program 
update announcements. To subscribe, send email to 
icc-cortex-subscribe@yahoogroups.com


  [ IDB Debugger ISSUES ]
  - If you have variables with the same names in nested scopes, the
    debugger may not display the correct variable in the watch window.

  [ST-LINK/V2 support: currently STM32F10xx /L15x/L162 are supported. We 
   will add support to other STM32 devices ASAP. ]

CHANGE LOGS:
V8.09.00 - 2014/08/22
  [ Upgraded to the latest protection engine for Win8 compatibility ]
  IDE
  - Added "File->Import project..." commands to add Keil MDK, and IAR
    project files.
  - Freescale Kinetis devices require 0x400 bytes to be skipped for the
    interrupt vectors instead of 0x200 for all other Cortex-M devices.

  IDE Debugger
  - Fixed an issue with setting data type with respect to watch points
  - New splash screen when the DebugBar window comes up.

  Driver (icccortex.exe)
  - When -MM0 is used, automatically add "-D_CORTEX_M0" to the C 
    Preprocessor.

  Compiler (iccomcortex.exe)
  - __weak attribute is parsed and ignored with a warning message emitted.

  Assembler (iascortex.exe)
  - Fixed bugs in the branch lengthening logic where it was asserting
    under some conditions.
  - Improved branch lengthening logic such that larger files would see
    1% o 2% smaller object code output by more optimial use of 16-bit 
    short branches.
  - Fixed incorrect encoding for some of the LDRSB/LDRB/LDRSH/LDRH 
    instructions.

V8.08.00 - 2014/04/07
  IDB DEBUGGER
  - [ PRO only ] Added support for viewing IO Registers in the debugger. 
    Not all devices are supported. We will add them as fast as we can.

  - [ PRO only ] Added support for mixed mode display in the "DebugBar"

  CB IDE
  - Automatically close the map and list files when you do a build since
    it renders the files out of date.

  - Fixed "Save Project As Template..."

  - "Project->Build Options->Paths" now use relative paths (relative to
    the project dir) if possible.

  - The STM32F105 entries had incorrect SRAM size (should be 64K)

  - Change the project name in the Project->Properties dialog box now
    works correctly.

  Compiler
  - Fixed bug with function arguments with % operations not working
    correctly.

  - Under some circumstances, the compiler generated incorrect debug
    line information.

  Assembler
  - The assembler might fail with assertion error under some conditions.

  Debugger and Flash Loader
  - ST-LINK/V2 support: added support for STM32F10x/L15x/L162 devices.

V8.07.02 - 2014/01/23
  CB/IDB
  - Improved error reporting regarding JTAG pod usage
  IDB
  - Fixed debugger crashing when watching a large data array object
  - Fixed some crashing issues with ST-LINK support

V8.07.01 - 2014/01/06
  CodeBlocks IDE and IDB
  - Fixed some crashing issues

  ST-LINK/V2 support
  - Added support for L152, e.g. STM L-Dsicvoery kits

  Compiler
  - 64-bits FP are now fully tested 

  Documentation
  - Added sections on reset and interrupt handling, programming the STM32
    peripherals etc. to the "Programming the Cortex M" chapter.

  Libraries
  - Removed stub vectors, SystemInit, etc.

  Examples 
  - Fixed errors
  - Changed examples.corstarter to use ST-LINK/V2 as the default pod

V8.07.00 - 2013/12/26
  Installer
  - Added DotNET 4 Web client profile dependency for DebugBar

  CodeBlocks IDE
  - Fixed some issues related to debugging

  C Preprocessor
  - Added
      #pragma once
    specifies that this file should only be processed once by the C
    preprocessor, even if it is #include multiple times.

  Compiler
  - Fixed a number of 64-bit long long defects

  ST-LINK/V2 support
  - Added the driver directory c:\iccv8cortex\ST-LINK_USB_VS_Driver.
  - Added support to F105RC

  Assembler/Linker
  - Eliminated 64K code limit of a single object file.

  Startup Code and Libraries
  - Eliminated the call to SystemInit() from the startup code and the default
    empty SystemInit() from the libraries

  Examples
  - Added CorStarter Examples c:\iccv8cortex\examples.Corstarter-stm32
  - Fixed SystemInit() issues with ST examples

V8.06.02 - 2013/11/16
  IDE
  - Fixed links to new Help files
  - Fixed issues with ST-LINK/V2 

V8.06.01 - 2013/11/07
  IDB/CodeBlocks
  - Enabled DebugBar, a new GUI for debugging.

V8.06.00 - 2013/11/05
  Help File
  - Changed to use Adobe Technical Communications 4 and made various
    content improvements.

  CodeBlocks IDE
  - For Freescale devices, add 0x410 as the flash offset to accomodate the 
    config registers
  - Fixed a bug with File->SaveAs...
  - Added File->SaveProjectAs...
  - Fixed defects with makefile generation (ImageCraft->Create Makefile)

  IDE/Debugger
  - Added to "Project->Build Options->Debugger" the ability to select the
    JTAG Pod (Segger Jlink or ST-LINK/V2) and JTAG vs. SWD interface.
  - Added options to icc_flash.exe to support the ST-LINK/V2

  Compiler
  - Added __forceregister storage class modifier. Should only be used on
    function parameters, particularly static inline function using asm()
    statements, e.g.

        static __inline unsigned __REV(__forceregister unsigned val)
            {
            asm("REV %val,%val");
            return val;
            }

  - Changed compiler so that it would not remove volatile read, e.g.

      extern volatile unsigned int i;
      ...
      i;   // used to be elided

8.05.02 - 2013/08/24
  IDE
  - Removed CMSIS Config Wizard as it is not very useful.

  Header File
  - Added bitband.h, see the file for complete description
    // 'a' is the address, e.g. &GPIOC->BRR, or &external_var
    // 'b' is the bit number and must be between 0 and 31 (inclusive)

    _BITBAND_CLEAR(a, b)
    _BITBAND_SET(a, b)
    _BITBAND_TOGGLE(a, b)
    _BITBAND_READ(a, b)

  Compiler
  - 8.05.01 was emitting incorrect structure size in the debug data. Fixed.
  - Eliminated unnecessary line number entries in debug data,
  - Fixed a rare bug with mixed mode arithmetic optimization.

  Libraries
  - Enabled using of libfpcortex.a and liblpcortex.a for different PRINTF versions.
    (Project->Build Options->Target->Printf)

8.05.01 - 2013/07/05
  Added "Device" name to the .mp map file. If you are working on an existing
    project, you must invoke the Build Options and then click OK for this new
    feature to appear in the map file.

  Debugger
  - Compiler did not generate correct debug info for local / param 
    variables (introduced in 8.05.00)
  CodeBlocks IDE
  - NXP LPC SRAM size was incorrectly reduced by half. This was necessary
    prior to using the Segger derived memory information file. Not needed
    any more.

    (If you are working on existing NXP projects, you must invoke the Build 
     Options and then click OK for this fix to take effect.)

8.05.00 - 2013/06/25
  - Added full versions of ftoa (printf %f/%g/%e). The default is the fast 
    and smaller version. The fast version cannot handle certain values 
	outside of a range. See comments in stdlib.h or Help file for details.

	To use, add 
	  ftoa-full-cortex

	to Project->BuildOptions->Target->"Extra Libraries" box

    We will add a GUI checkbox later.
  IDB Debugger
  - Added "Reset Target" command and toolbar button
  - Fixed miscellaneous bugs
  Compiler
  - Under PRO license, enabled removal of static inline functions if all
    uses are inlined.
  - Under PRO license, removed static functions if there is no code in
    the function.
  - Fixed bugs with inline codegen support
  - Fixed miscellaneous bugs
  Assembler
  - Added MSR/MRS, LDREX?/STREX? instructions
  - Fixed not assembling "ldr Rx,[Ry]" bug
  - Fixed "LDR Rx,LIT+..." issues
  Header File
  - Use CMSIS V3 header files from ARM
  - Added Cortex instruction intrinsics to core_cmInstr.h
  Listing File (.lst file)
  - Improved LITERAL pools handling
  Libraries
  - revamped ftoa()
  - added full version of ftoa
  Examples
  - Added FreeRTOS port and demo for STM32

8.04.00  - April 29, 2013
  [ STD / NC / DEMO now have a limit of 128K. EXPIRED DEMO is 32K ]
  IDB Debugger
  - Watch and Disassembly windows were broken in 8.03.01
  - Fixed problem with incorrect dongle license handling
  Compiler
  - Added support for __inline. This eases porting of examples for other
    compilers.
  Dongle Driver
  - V2 license dongle driver
  Examples
  - Added EFM32 LED Blinking program

8.03.01  - Mar 18, 2013
  IDB Debugger
  - Fixed some crash issues with project path with spaces and other issues.
  - Fixed stepping in / out issues.

  Compiler
  - Added support for __packed, it must precede the "struct" or "union"
    keyword. When present, then all the elements of the aggregate is packed
	with alignment holes. This slows down the access, but could be important 
	when you are writing protocol firmware.

  ICC_Flasher.exe
  - Fixed issue with not resetting the target correctly on some devices.

  Header Files
  - Added TI LM header files

  Examples
  - Restructued STM32 example to be cleaner

8.03.00 Dec4th, 2012
  First IDB (ImageCraft Debugger) release. IDB is fully integrated with the 
  CB IDE. Supports Segger JLINK emulators,
  - Fully functional under the PRO license. It will automatically download 
    the project output.
  - With DEMO/-NC/STD licenses, the debugger is limited to a single 
    breakpoint and up to 64K code code.
  - With expired demo, the debugger is not functional.

  Enabled dongle license

  Compiler
  - bug fixes and feature enhancements

8.01.00 Sept 19, 2012
  CodeBlocks IDE
  - Started integration with the Segger JLink. Added icc_flash.exe to Tools->
    "Flash Utility for Segger." If a Segger Jlink pod is attached, this will
    program the output of the current project based on the selected device.
  - Added Tools->Generate Makefile 

  Compilers
  - Some bug fixes

8.00.00 August 24th, 2012
  - Open c:\iccv8cortex\examples.cortex\examples.workspace for some sample 
    projects
 
  - ARM CMSIS header files under c:\iccv8cortex\include\CMSIS, the compiler
    driver automatically includes this directory (along with
    c:\iccv8cortex\include\) in the search list.

  - NXP header files under c:\iccv8cortex\include\<vendor name>\
    You will have to explicitly add them to the Include Path, e.g.
       $(TARGET_COMPILER_DIR)NXP\LPC17xx\

  - No vendor CMSIS source files are included as they are rather large. 
    Please download them from the vendors' sites.

  - Please refer to the documentation, "Programming for Cortex-M" on what
    steps to take to get a working project.

